/**
 * \file: icp.c
 *
 * \brief AVR135: PWMޭè ّւϕߊlgp
 *
 * 쌠 (C) 2016 Atmel Corporation. s
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 */
/*
 * xFAQ: <a href="http://www.atmel.com/design-support/">Atmelx</a>q˂ĂB
 */
 
#include <avr/io.h>
#include <avr/interrupt.h>
#include "icp.h"
#include "device.h"

/**
 * icp_start_time, icp_stop_time, icp_period
 *
 * pԕϐB
 *
 * start_time,stop_time,period͊eXTCNTڼ޽Ɠ^܂B
 */
typedef unsigned int icp_timer_t;			// TCNT1Ɠ
icp_timer_t icp_start_time, icp_stop_time;
icp_timer_t icp_period;

/**
 * icp_rx_q[]
 *
 * ꂽ̎li[
 *
 * rx_q̗vfޭè ق̌ʂƓ^܂B
 */
icp_sample_t icp_rx_q[ICP_RX_QSIZE];

/**
 * icp_rx_tail, icp_rx_head
 *
 * icp_rx_qɑ΂҂sԕϐ
 *
 * rx_headrx_tail̎wW[0:ICP_RX_QSIZE]ɓK̂ɏ[ȕKvłB
 * QSIZEʓIɂ܂傫ׂł͂Ȃ̂ŁA͊Tˈ̍ŏP
 * ʊ֌W𓾂P޲ĂƂČŒ艻܂B
 */
unsigned char icp_rx_tail;		// icp_rx_qɏՕ݈ʒuwq
#if !ICP_ANALOG					/* ICP_DIGITAL:޼ْlFȂA */
unsigned char icp_rx_head;		// icp_rx_qɏՕǂݍ݈ʒuwq
#endif

#if ICP_ANALOG
/**
 * icp_total
 *
 * ۸ޒl̎(ICP_ANALOG)ɑ΂ړόvZŎgp
 *
 * icp_totalRX_QSIZEicp_sample_t̎摍vɓK̂ɏ[ȕKv
 * B
 */
icp_total_t icp_total;
#endif	/* ICP_ANALOG */

/**
 * icp_duty_compute()
 *
 * ̊֐(ICP_SCALE~ٽ)/̒lvZ܂B
 * ͎̏Z֐łAȉ̂悤(longZƎ㓙)r@
 * gp܂B
 * 1) 32ޯĉZKv܂(̌vZ͌24+ޯĂł)B
 * 2) 8ޯĂ̌ʂɂ(ʂ16/16p16ɑウ)8̌JԂKvłB
 * 3) Cŏ肭߲ق܂B
 * log2(ICP_SCALE)ޯĂS֌WȂ悤ٽĂ
 * ̂ŁAœ܂B
 */
static icp_sample_t icp_duty_compute(icp_timer_t pulsewidth, icp_timer_t period)
{
	icp_sample_t r, mask;

	mask = ICP_SCALE >> 1;					// ޯĒl擾(ICP_SCALE/2:Ȃ=$80)
	r = 0;									// 
	do
	{
		period >>= 1;						// =/2
		if (pulsewidth >= period)			// 폜ŁA
		{
			r |= mask;						// Ήޯ=1
			pulsewidth -= period;			// 폜=폜-݂̏
		}
		mask >>= 1;							// ޯĒl1ޯĉEړ(1/2)
	} while (pulsewidth != 0 && mask != 0);	// Z܂Ōp
	return(r);
}

/**
 * icp_enq()
 *
 * V(̎l)M҂sɊi[
 */
static void icp_enq(icp_sample_t sample)
{
	unsigned char t;

	t = icp_rx_tail;					// ɏՕ݈ʒuwq
#if	ICP_ANALOG							/* ۸ޒlFȂA*/
	icp_total += sample - icp_rx_q[t];	// ɏՕo̒l̍ōvl␳
#endif
	icp_rx_q[t] = sample;				// ̎()ɏՕ֊i[
	if (++t >= ICP_RX_QSIZE)			// ɏՕŌzŁA
		t = 0;							// ɏՕ擪ʒul擾
#if	!ICP_ANALOG							/* ޼ْlFȂA*/
	if (t != icp_rx_head)				// ɏՕ󂫗LŁA
#endif
		icp_rx_tail = t;				// ɏՕ݈ʒuwqXV
	return;
}

/**
 * TIMER1_COMPA()
 *
 * ICPp/rv荞ݏٰ
 *
 * rv荞݂͈鴯ނӐ}悤ɂėȂƂ܂B
 * ޭè ق0%(SĂɉٽSȂ)܂100%(ٽŜ荞
 * )̂ǂ炩̎ɋN܂B
 */
ISR(TIMER1_COMPA_vect)
{
	icp_sample_t sample;

	ICP_OCR += icp_period;									// po
	sample = 0;												// ޭè0%
	if ((ICP_CTL & (1 << ICP_SENSE)) != ICP_START_SENSE)	// ݂s[ołȂ΁A
		sample = ICP_SCALE - 1;								// ޭè100%ɕύX

	icp_enq(sample);										// ̎lƂĊɏՕ֊i[
	return;
}

/**
 * TIMER1_CAPT()
 *
 * ICPߊl荞ݏٰ
 *
 * ICR擾Aĕߊl𔽓]܂B]ƒICRĂ
 * XV\邽߁A͂̏ōsȂ΂Ȃ܂B
 */
ISR(TIMER1_CAPT_vect)
{
	icp_timer_t icr, delta;
	unsigned char tccr1b;

	icr = ICR1;									// ߊll擾

	do
	{
		tccr1b = ICP_CTL;						// TCCR1Bl擾
		ICP_CTL = tccr1b ^ (1 << ICP_SENSE);	// ߊl]
		if ((tccr1b & (1 << ICP_SENSE)) == ICP_START_SENSE)		// s[ŁA
		{
			icp_period = icr - icp_start_time;			// O̎擾
			delta = icp_stop_time - icp_start_time;		// Oٽ擾
			icp_start_time = icr;						// ICRl̊JnlƂĕۑ/ݒ
			ICP_OCR = icr + icp_period + 1;		// Ď(rv)Đݒ
			REG_TIMER_INTFLAG = (1 << ICP_OC_IF);		// rv荞ݗv׸މ
			icp_enq(icp_duty_compute(delta,icp_period));	// ޭè ٌvZAʂɏՕɊi[
			if ((ICP_PIN & (1 << ICP_BIT)) || (REG_TIMER_INTFLAG & (1 << ICP_IF)))	// s\ɒZٽŁA
				break;							// ܂͉炩̏
		}
		else									// s[ŁA
		{
			icp_stop_time = icr;				// ~[ߊllۑ
			if ((!(ICP_PIN & (1 << ICP_BIT))) || (REG_TIMER_INTFLAG & (1 << ICP_IF)))	// s\ɒZٽŁA
				break;							// ܂͉炩̏
		}
		/*
		 * ɗꍇ͒Z܂͒ٽŁA0%܂100%
		 * ƂďׂłB͔rv荞݂ɂčs܂B
		 */
	} while (1);
	return;
}

/**
 * icp_rx()
 *
 * ҂s񂩂玎(̎l)擾܂B۸ޒlɑ΂āA͍ŌQSIZE
 * ǂݎ̈ړϒlłB޼ْlɑ΂Ă͍ŏIǂݎlłB
 */
icp_sample_t icp_rx(void)
{
	icp_sample_t r;

#if ICP_ANALOG							/* ۸ޒlFȂA */
	r = icp_total / ICP_RX_QSIZE;		// ŌQSIZEǂݎ̈ړϒl擾
#else									/* ޼ْlFȂA */
	unsigned char h;

	h = icp_rx_head;					// ɏՕǂݍ݈ʒuwq
	if (h == icp_rx_tail)				// ɏՕŁA
		r = (icp_sample_t)-1;			// lݒ
	else
	{
		r = icp_rx_q[h];				// ɏՕ̎l擾
		if (++h >= ICP_RX_QSIZE)		// ɏՕŌBŁA
			h = 0;						// ɏՕ擪ʒu擾
		icp_rx_head = h;				// ɏՕǂݍ݈ʒuwqXV
	}
#endif	/* ICP_DIGITAL */
	return(r);
}

/**
 * icp_init()
 *
 * ICPߊl͏
 */
void icp_init(void)
{
	ICP_CTL_A = 0;									// TCCR1A
	ICP_OCR	= 0;									// rl(őĎ)
	ICP_CTL	= (1 << ICES1) | ((0 << CS12) | (0 << CS11) | (1 << CS10));		// s(㏸)[w,T/C1n
	ICP_TIMSK	|= ICP_TIMSK_MASK;					// ߊl荞݂Ɣrv荞݂
	return;
}
